//+------------------------------------------------------------------+
//|                                             MinMax indicator     |
//|                                                            Mikko |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Mikko"
#property link      "noneOfYOurBusiness"

//#property indicator_separate_window
#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Silver
#property indicator_color2 Silver
#property indicator_color3 Red
#property indicator_color4 Blue

double high[];
double low[];
double middle[];
double open[];

extern int period = PERIOD_D1;

int init() {

   IndicatorBuffers(4);
   SetIndexBuffer(0, high);   
   SetIndexStyle(0, DRAW_LINE, EMPTY, 1); 
   
   SetIndexBuffer(1, low);     
   SetIndexStyle(1, DRAW_LINE, EMPTY, 1);
   
   SetIndexBuffer(2, middle);     
   SetIndexStyle(2, DRAW_LINE, EMPTY, 1);
   
   SetIndexBuffer(3, open);     
   SetIndexStyle(3, DRAW_LINE, EMPTY, 1);
   
   IndicatorShortName("Mikko HighLow Period");
   
   if(period == 0)
      period = Period();
      
   return(0);
}
  
int deinit() {
   return(0);
}
     
int start() {
       
   int counted_bars=IndicatorCounted();
  
   if(counted_bars < 0) 
       return(-1);
   if(counted_bars > 0) 
       counted_bars--;
       
   int limit = Bars - counted_bars;   
   
   for(int i = limit; i >= 0; i--) {
   
       datetime t = iTime(Symbol(),period,iBarShift(Symbol(), period, Time[i], true));
       
       if(Time[i+1] <= t && Time[i] >= t) {
          low[i] = Low[i];
          high[i] = High[i];
          open[i] = Open[i];
       } else {
       
          if(Low[i] < low[i+1]) 
            low[i] = Low[i];
          else
            low[i] = low[i+1];
            
          if(High[i] > high[i+1])
            high[i] = High[i];
          else
            high[i] = high[i+1];
          
          open[i] = open[i+1];
       }
       middle[i] = (low[i]+high[i])/2;
   } 
   return(0);
}

